package com.qucheng.game.data.oldsystem.dao.mapper;

import org.apache.ibatis.annotations.Param;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public interface BaseMapper {

    Map<String, Object> getById(@Param("tableName") String tableName,
                                @Param("primaryKeyMap") Map<String, Object> primaryKeyMap);

    Map<String, Object> queryOne(@Param("tableName") String tableName,
                                 @Param("queryParamMap") Map<String, Object> queryParamMap);

    List<Map<String, Object>> queryList(@Param("tableName") String tableName,
                                        @Param("queryParamMap") Map<String, Object> queryParamMap);

    default int saveOrUpdate(String tableName, List<String> primaryKeys, Map<String, Object> obj) {
        List<String> fieldList = new ArrayList<>(obj.size());
        List<Object> valueList = new ArrayList<>(obj.size());
        Map<String, Object> updateParamMap = new HashMap<>(obj.size());
        for (Map.Entry<String, Object> entry : obj.entrySet()) {
            fieldList.add(entry.getKey());
            valueList.add(entry.getValue());
            if (primaryKeys.contains(entry.getKey())) {
                continue;
            }
            updateParamMap.put(entry.getKey(), entry.getValue());
        }
        return insertOrUpdate(tableName, fieldList, valueList, updateParamMap);
    }

    int insertOrUpdate(@Param("tableName") String tableName,
                       @Param("fieldList") List<String> fieldList,
                       @Param("valueList") List<Object> valueList,
                       @Param("updateParamMap") Map<String, Object> updateParamMap);

    int delById(@Param("tableName") String tableName,
                @Param("primaryKeyMap") Map<String, Object> primaryKeyMap);
}
